#!/bin/bash
#
# Run the program with the Mars4_5 MIPS simulator in a sandbox
# (c) 2019-2020, Arturo Gonzalez-Escribano
#

CODE=$1
shift

# LINES COUNT
#echo Code lines: $(wc -l ../usercodes/src/$CODE | cut -d " " -f 1)
echo Code lines: $(./CuentaSin ../usercodes/src/$CODE)
# COPY THE CODE IN THE SANDBOX ADD THE MAIN FUNCTION
#cp ../usercodes/src/$CODE /home/sandbox/exec/
cat ../usercodes/src/main-tablon.asm ../usercodes/src/$CODE > /home/sandbox/exec/$CODE
cd /home/sandbox/exec/

# TRANSFORM INPUT LINE IS stdout WITH LINE BREAKS
INPUT=$(sed "s/#/\n/g" <<< "$@")

# EXECUTION AND RESULTS
( sudo -u sandbox /usr/bin/java -jar /home/sandbox/bin/Mars4_5.jar nc me se1 ic sm $CODE <<<"$INPUT" | sed 's/.*/Result: &/' ; exit ${PIPESTATUS[0]} ) 3>&1 1>&2 2>&3 | sed 's/^[0-9]\+$/Instructions executed: &/' | sed 's/\/home\/sandbox\/exec\/p[0-9]\+\.asm \?//'
EXIT_CODE=${PIPESTATUS[0]}

# CLEAN SANDBOX
rm $CODE

exit $EXIT_CODE
